# The contents of this file are subject to the Common Public Attribution License
# Version 1.0 (the “License”); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
# https://myou.dev/licenses/LICENSE-CPAL. The License is based on the Mozilla
# Public License Version 1.1 but Sections 14 and 15 have been added to cover use
# of software over a computer network and provide for limited attribution for
# the Original Developer. In addition, Exhibit A has been modified to be
# consistent with Exhibit B.
#
# Software distributed under the License is distributed on an “AS IS” basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
# the specific language governing rights and limitations under the License.
#
# The Original Code is Myou Engine.
#
# the Original Developer is the Initial Developer.
#
# The Initial Developer of the Original Code is the Myou Engine developers.
# All portions of the code written by the Myou Engine developers are Copyright
# (c) 2024. All Rights Reserved.
#
# Alternatively, the contents of this file may be used under the terms of the
# GNU Affero General Public License version 3 (the [AGPL-3] License), in which
# case the provisions of [AGPL-3] License are applicable instead of those above.
#
# If you wish to allow use of your version of this file only under the terms of
# the [AGPL-3] License and not to allow others to use your version of this file
# under the CPAL, indicate your decision by deleting the provisions above and
# replace them with the notice and other provisions required by the [AGPL-3]
# License. If you do not delete the provisions above, a recipient may use your
# version of this file under either the CPAL or the [AGPL-3] License.


when not (defined(isNimSkull) or defined(myouUseMainline)):
    {.error:"""Mainline Nim is not compatible with myou-engine at the moment.
    If you want to try anyway, add -d:myouUseMainline """.}

import ./attributes
import ./postprocessing/effect_shaders
import ./math_utils/g3
import ./graphics/framebuffer
import ./graphics/material
import ./graphics/render
import ./graphics/texture
import ./graphics/ubo
import ./incomplete
import ./input
import ./loaders/blend
import ./loaders/loader_base
import ./myou_engine
import ./objects/camera
import ./objects/cubemap_probe
import ./objects/gameobject
import ./objects/light
import ./objects/mesh
import ./shadows/shadow_common
import ./shadows/simple_shadow
import ./quat
import ./scene
import ./screen
import ./types
import ./util
import std/tables
import vmath except Quat

export attributes
export blend
export camera
export cubemap_probe
export effect_shaders
export framebuffer
export g3
export gameobject
export incomplete
export input
export light
export loader_base
export material
export mesh
export myou_engine
export quat
export render
export scene
export screen
export shadow_common
export simple_shadow
export tables
export texture
export types
export ubo
export util
export vmath except Quat

import platform/platform
when defined(android):
    export platform.myouAndroidGetActivity
    export platform.myouAndroidGetJniEnv
    export platform.myouAndroidGetInternalDataPath
    export platform.myouAndroidGetExternalDataPath

export platform.myouSetKeyboardVisible
