

#define TXT_SCALE 8.0
    
uniform sampler2D txr_font;     // ASCII 32x8 characters font texture unit
//---------------------------------------------------------------------------
const int _txtsiz=32;           // text buffer size
int txt[_txtsiz],txtsiz;        // text buffer and its actual size
//---------------------------------------------------------------------------
void txt_decimal(float x)       // print float x into txt
{
    int i,j,c;          // l is size of string
    float y,a;
    const float base=10.0;
    // nan
    if(x != x) {
        txt[txtsiz]='n';
        txt[txtsiz+1]='a';
        txt[txtsiz+2]='n';
        txtsiz+=3;
        txt[txtsiz]=0;
        return;
    }
    // handle sign
    if (x<0.0) { txt[txtsiz]='-'; txtsiz++; x=-x; }
     else      { txt[txtsiz]='+'; txtsiz++; }
    // inf
    if((x-1e10) == x) {
        txt[txtsiz]='i';
        txt[txtsiz+1]='n';
        txt[txtsiz+2]='f';
        txtsiz+=3;
        txt[txtsiz]=0;
        return;
    }
    // divide to int(x).fract(y) parts of number
    y=x; x=floor(x); y-=x;
    // handle integer part
    i=txtsiz;                   // start of integer part
    for (;txtsiz<_txtsiz;)
        {
        a=x;
        x=floor(x/base);
        a-=base*x;
        txt[txtsiz]=int(a)+'0'; txtsiz++;
        if (x<=0.0) break;
        }
    j=txtsiz-1;                 // end of integer part
    for (;i<j;i++,j--)      // reverse integer digits
        {
        c=txt[i]; txt[i]=txt[j]; txt[j]=c;
        }
    // handle fractional part
    for (txt[txtsiz]='.',txtsiz++;txtsiz<_txtsiz;)
        {
        y*=base;
        a=floor(y);
        y-=a;
        txt[txtsiz]=int(a)+'0'; txtsiz++;
        if (y<=0.0) break;
        }
    txt[txtsiz]=0;  // string terminator
}
//---------------------------------------------------------------------------
vec4 txt_print(vec4 col, float x0,float y0)   // print txt at x0,y0 [chars]
{
    int i;
    float x,y;
    // fragment position [chars] relative to x0,y0
    x = mod((gl_FragCoord.x - x0)/TXT_SCALE, 32.0);
    y = mod((gl_FragCoord.y - y0)/TXT_SCALE, 2.0);
    // inside bbox?
    if ((x<0.0)||(x>float(txtsiz))||(y<0.0)||(y>1.0)) return col;
    y = 1.0 - y;
    // get font texture position for target ASCII
    i=int(x);               // char index in txt
    x-=float(i);
    i=txt[i];
    x+=float(int(i-((i/32)*32)));
    y+=float(int(i/32));
    x/=32.0; y/=8.0;    // offset in char texture
    return texture(txr_font,vec2(x,y));
}

vec4 txt_print(){ return txt_print(vec4(0), 0.0, 0.0); }
