

float get_shadow(vec3 position, vec3 normal, float findex) {
#if MAX_SHADOW_MAPS
    ShadowMapInfo info = shadow_map_infos[int(findex)];
    float px_size = 1.5/info.size;
    vec3 p = position + normal * info.bias * 2.0;
    vec3 co = vec3(info.depth_matrix * vec4(p, 1.0));
    if(co.x <= 0.0 || co.x >= 0.999999 || co.y <= 0.0 || co.y >= 0.999999) return 1.0;
    co.z = min(co.z, 0.999999);
    float count = 0.0;
    float vis = 0.0;
    // TODO: better and faster filtering by using radial samples
    //       and testing outer ring first
    // return texture(shadow_maps, vec4(co.xy, findex, co.z)).r;
    // return texture(shadow_maps, vec3(co.xy,findex)).r;
    for(float y=co.y-px_size;y<=co.y+px_size;y+=px_size*0.499){
        for(float x=co.x-px_size;x<=co.x+px_size;x+=px_size*0.499){
#if USE_SHADOW_SAMPLERS
            vis += texture(shadow_maps, vec4(x,y, findex, co.z));
#else
            vis += texture(shadow_maps, vec3(x,y,findex)).r <= co.z?0.0:1.0;
#endif // USE_SHADOW_SAMPLERS
            count += 1.0;
        }
    }
    return vis/count;
#else
    return 1.0;
#endif // MAX_SHADOW_MAPS
}

